import es
import nativetools as nt

def touchCallback(index, touched):
    userid = nt.getUseridByIndex(index)
    if es.exists('userid', userid):
        if touched and index != touched:
            _touched = nt.getUseridByIndex(touched)
            if es.exists('userid', _touched):
                if es.getplayerteam(userid) == es.getplayerteam(_touched):
                    es.setplayerprop(userid, 'CBaseEntity.m_CollisionGroup', 2)
                else:
                    es.setplayerprop(userid, 'CBaseEntity.m_CollisionGroup', 5)
        else:
            es.setplayerprop(userid, 'CBaseEntity.m_CollisionGroup', 5)

def registerUserid(userid):
    userid = int(userid)
    nt.touchRegister(int(es.createplayerlist(userid)[userid]['index']), touchCallback, True, 'player')

def unregisterUserid(userid):
    userid = int(userid)
    nt.touchUnregister(int(es.createplayerlist(userid)[userid]['index']), touchCallback)

def load():
    es.ServerVar('bnb_ver', 1, "BackRaw's NoBlock - TeamOnly").makepublic()
    nt.preEventRegister('player_disconnect', preDisconnect)
    for x in es.getUseridList():
        registerUserid(x)

def unload():
    nt.preEventUnregister('player_disconnect', preDisconnect)
    for x in es.getUseridList():
        unregisterUserid(x)

def player_activate(ev):
    registerUserid(ev['userid'])

def preDisconnect(ev):
    unregisterUserid(ev['userid'])